#!bash
# add path (important: if path is missing, no command will be found) and remove doubles
export PATH=/usr/local/bin:/usr/bin:/bin:/lib:`echo "$PATH" | /bin/sed "s=/usr/local/bin:/usr/bin:/bin:/lib:==g"`

echo "synchronizing files.."
function copyfile() 
{
  local SOURCEFILE=$1
  local TARGETFILE=$2

  echo "writing $TARGETFILE"
  cp --preserve -f $SOURCEFILE $TARGETFILE
}

function iterate() 
{
  if test ! -e $2; then
    mkdir $2
  fi

  # now sync subfolders
  for FILE in `ls -l $1 2>/dev/null| gawk '/^d/ {print $9}'`
  do
      SOURCEFILE=$1/$FILE
      TARGETFILE=$2/$FILE

      iterate $SOURCEFILE $TARGETFILE
  done

  # now sync files in folder
  ls -l --full-time $1 2>/dev/null| gawk '/^-/ {print $9":"$5":"$6":"$7":"$8":"$10":"$11}'|gawk -F: '{secs = ($1*60+$2)*60+$3+1; print $9" "int(secs/2)"-"$4$5$6$7$8}'>/tmp/sourcedate
  ls -l --full-time $2 2>/dev/null| gawk '/^-/ {print $9":"$5":"$6":"$7":"$8":"$10":"$11}'|gawk -F: '{secs = ($1*60+$2)*60+$3+1; print $9" "int(secs/2)"-"$4$5$6$7$8}'>/tmp/targetdate
  
  for FILE in `diff /tmp/sourcedate /tmp/targetdate | gawk '/^</ {print $2}'`
  do
      SOURCEFILE=$1/$FILE
      TARGETFILE=$2/$FILE

      copyfile $SOURCEFILE $TARGETFILE
  done

}

SOURCE=$1
TARGET=$2
iterate $SOURCE $TARGET
echo "..done!"