#!bash
# add path (important: if path is missing, no command will be found) and remove doubles
export PATH=/usr/local/bin:/usr/bin:/bin:/lib:.:`echo "$PATH" | /bin/sed "s=/usr/local/bin:/usr/bin:/bin:/lib:==g"`

export TEAM_DIR=`echo $0 |sed 's@\(.*\)/Make.*@\1@' |sed 's@/cygdrive/\(.\)\(.*\)@/cygdrive/\1/\2@'`
cd $TEAM_DIR/Make
#TEAM_DIR is for example c:/GT2004 or c:/DT2005

echo "! copyfiles-package.bash $*"
echo "!"

echo "Team base dir is $TEAM_DIR"
# defaults
HELP=0
FORCE=0
UPD=""
PAUSE=0
NOPLAYER=1
ERS7=1
RM=0
EJECT=0
WLAN=WLAN
UNSAFE=0

if test x$1 = x; then
  echo "usage:"
  echo "  copyfiles-package.bash <package-name>"
else

  if test x$MSD = x; then
    MSDCURRENT="$TEAM_DIR/Deployment/CurrentStick"
    MSD=$MSDCURRENT
    MSDZIP=$TEAM_DIR/Deployment/Binaries/$1
    echo "preparing package at $MSD"
    if test -d $MSD; then
      chmod -R +w $MSD
      rm -rf $MSDCURRENT
      echo "  cleaned folder"
    fi
    mkdir $MSDCURRENT
  fi

  MSOPENR=$TEAM_DIR/Build/MS/open-r
  echo "using open-r tree from $MSOPENR"

  if test -d $MSD; then
    if test x$UPD = x; then
      DEBUG_MODE=`grep DebugMode $MSOPENR/APP/CONF/CONFIG.CFG | sed "s%DebugMode %%"`
      if test $ERS7 = 0; then
        if test -d /usr/local/OPEN_R_SDK_ERS7; then # 1.1.4 / 1.1.5 dual installation?
          MSTREE=/usr/local/OPEN_R_SDK_ERS210/OPEN_R/MS/$WLAN/$DEBUG_MODE/
        else
          if test -d /usr/local/OPEN_R_SDK/OPEN_R/MS_ERS200; then # 1.1.5 installation?
            MSTREE=/usr/local/OPEN_R_SDK/OPEN_R/MS_ERS200/$WLAN/$DEBUG_MODE/
          else # 1.1.4 installation
            MSTREE=/usr/local/OPEN_R_SDK/OPEN_R/MS/$WLAN/$DEBUG_MODE/
          fi
        fi
      else
        if test -d /usr/local/OPEN_R_SDK_ERS7; then # 1.1.4 / 1.1.5 dual installation?
          MSTREE=/usr/local/OPEN_R_SDK_ERS7/OPEN_R/MS_ERS7/$WLAN/$DEBUG_MODE/
        else # 1.1.5 installation
          MSTREE=/usr/local/OPEN_R_SDK/OPEN_R/MS_ERS7/$WLAN/$DEBUG_MODE/
        fi
      fi
      echo "using ms tree from $MSTREE"
	pwd
      copy-update.bash $MSTREE/open-r $MSD/open-r
      if test $UNSAFE = 1; then
        chmod u+w $MSD/OPEN-R/SYSTEM/CONF/EXTOBJ.CFG
        grep -v EMGCYMON $MSTREE/OPEN-R/SYSTEM/CONF/EXTOBJ.CFG >$MSD/OPEN-R/SYSTEM/CONF/EXTOBJ.CFG
        chmod u-w $MSD/OPEN-R/SYSTEM/CONF/EXTOBJ.CFG
      fi
    fi
    

    #needed to avoid entering "start":
    mkdir -p $MSD/open-r/OTHERS/PSH
    mkdir -p $MSD/open-r/system/conf
    echo "start" > $MSD/open-r/OTHERS/PSH/PSH.RC
    echo " " > $MSD/open-r/system/conf/MAV.CFG ;
    echo " " > $MSD/open-r/system/conf/OBJECT2.CFG ;
    if test $ERS7 = 1; then
      echo "JamDetectionHighThreshold" > $MSD/open-r/system/conf/VRCOMM.CFG
    fi
    
    #own binary stuff has to be copied always if --update is not given
    copy-update.bash $MSOPENR/APP $MSD/open-r/APP

    # copy tinyftpd server
    cp --preserve -u $TEAM_DIR/Util/TinyFTPD/bin/TINYFTPD.BIN $MSD/open-r/app/objs/tinyftpd.bin
   
    #sound files only have to be updated
    mkdir -p $MSD/open-r/app/conf/Sounds
    cp --preserve -u $TEAM_DIR/Config/Sounds/*.wav $MSD/open-r/app/conf/Sounds

    cp --preserve $UPD $TEAM_DIR/Config/empty_debug_request.dat $MSD/open-r/app/conf/requests.dat
    cp --preserve $UPD $TEAM_DIR/Config/spec_act.dat $MSD/open-r/app/conf/spec_act.dat
    cp --preserve $UPD $TEAM_DIR/Config/nc_pop1.dat $MSD/open-r/app/conf/nc_pop1.dat
    rm -f $MSD/open-r/app/conf/udset7.dat
    cp --preserve $UPD $TEAM_DIR/Config/udset7.dat $MSD/open-r/app/conf/udset7.dat
    cp --preserve $UPD `ls $TEAM_DIR/Config/*.cfg | grep -v player |grep -v obotgw` $MSD/open-r/app/conf

    mkdir -p $MSD/open-r/mw
    cp --preserve -u $TEAM_DIR/Config/robotgw.cfg $MSD/open-r/mw/conf

    mkdir -p $MSD/open-r/app/conf/Xabsl2
    cp --preserve -r $UPD $TEAM_DIR/Config/Xabsl2/* $MSD/open-r/app/conf/Xabsl2

    mkdir -p $MSD/open-r/app/conf/Pfield/GT2004
    cp --preserve $UPD $TEAM_DIR/Config/Pfield/GT2004/*.pfc $MSD/open-r/app/conf/Pfield/GT2004

    LOCATION=`grep -v "\*" $TEAM_DIR/Config/location.cfg | grep "[A-Za-z0-9]"`
    if test x$LOCATION != x; then
      mkdir -p $MSD/open-r/app/conf/Location/$LOCATION
      # copy model-unspecific files only if they exist
			if test -n "$(ls -p1 $TEAM_DIR/Config/Location/$LOCATION/ | grep -v /)"; then
      	cp --preserve $TEAM_DIR/Config/Location/$LOCATION/*.* $MSD/open-r/app/conf/Location/$LOCATION
      fi
      if test $ERS7 = 0; then
      	MODEL="ers210"
      else
      	MODEL="ers7"
      fi
      mkdir -p $MSD/open-r/app/conf/Location/$LOCATION/$MODEL
      cp --preserve $TEAM_DIR/Config/Location/$LOCATION/$MODEL/*.* $MSD/open-r/app/conf/Location/$LOCATION/$MODEL
    fi
    cp --preserve $UPD $TEAM_DIR/Config/*.tab $MSD/open-r/app/conf

    if test $NOPLAYER = 0; then
      cp --preserve $UPD  $TEAM_DIR/Config/player.cfg $MSD/open-r/app/conf
      if test -f $TEAM_DIR/Config/wlanconf.txt; then
        cp --preserve $UPD $TEAM_DIR/Config/wlanconf.txt $MSD/open-r/system/conf
      else
        echo "$TEAM_DIR/Config/wlanconf.txt not found, create it, e.g. with PlayersToolbar:Save"
      fi
    fi

    echo "Zipping package to $MSDZIP"
    cd $MSD
    tar cf - . | gzip > $MSDZIP
    ls -l $MSDZIP
    echo
    echo "Done!"
    cmd /C pause


  else
    echo ERROR: $MSD does not exist. Insert MemoryStick!
    cmd /C pause
  fi

fi
#
# Change Log:
#
# $Log: copyfiles-package.bash,v $

