#!bash
# add path (important: if path is missing, no command will be found) and remove doubles
export PATH=/usr/local/bin:/usr/bin:/bin:/lib:`echo "$PATH" | /bin/sed "s=/usr/local/bin:/usr/bin:/bin:/lib:==g"`

export TEAM_DIR=`pwd |sed 's@\(.*\)/Make.*@\1@' `
#TEAM_DIR is for example  /cygdrive/e/DT2005
pwd
echo "! copyfiles-prepare.bash $*"
echo "!"

echo "Team base dir is $TEAM_DIR"


if test x$1 = x; then
  echo "usage:"
  echo "  copyfiles-package.bash <package-name> <coltable-name>"
else

  if test x$MSD = x; then
    MSD="$TEAM_DIR/Deployment/CurrentStick"
    MSDZIP=$TEAM_DIR/Deployment/Binaries/$1
    echo "preparing package at $MSD"
    if test -d $MSD; then
      chmod -R +w $MSD
      rm -rf $MSD
      echo "  cleaned folder"
    fi
    mkdir $MSD
  fi

  cd $MSD
  echo "  extracing files from package"
  tar -xzf $MSDZIP
  echo

  COLTABLE="$TEAM_DIR/Deployment/Colortables/$2"
  echo "copying colortable from $COLTABLE"

  if test -d $COLTABLE; then
    rm -f $TEAM_DIR/Config/Location/Osaka/ers7/*.c64
    rm -f $MSD/open-r/APP/conf/Location/Osaka/ers7/*.c64
    rm -f $TEAM_DIR/Config/Location/Osaka/*.c64
    rm -f $MSD/open-r/APP/conf/Location/Osaka/*.c64

    # normal color table
    cp --preserve $COLTABLE/coltable.c64 $MSD/open-r/APP/conf/Location/Osaka/ers7/coltable.c64
    cp --preserve $COLTABLE/coltable.c64 $TEAM_DIR/Config/Location/Osaka/ers7/coltable.c64

    # task image processor colortables (fix this: same path as other coltables!)
    cp --preserve $COLTABLE/*.c64 $MSD/open-r/APP/conf/Location/Osaka
    cp --preserve $COLTABLE/*.c64 $TEAM_DIR/Config/Location/Osaka

    # specialvision: variable lighting colortables & startup camera info
    cp --preserve $COLTABLE/*.c64 $MSD/open-r/APP/conf/Location/Osaka/ers7
    cp --preserve $COLTABLE/*.c64 $TEAM_DIR/Config/Location/Osaka/ers7
    cp --preserve $COLTABLE/camera.cfg $MSD/open-r/APP/conf/Location/Osaka/ers7

    # specialvision: variable lighting config file
    cp --preserve $COLTABLE/lighting.cfg $TEAM_DIR/Config/Location/Osaka/ers7
    cp --preserve $COLTABLE/lighting.cfg $MSD/open-r/APP/conf/Location/Osaka/ers7

    cp --preserve $COLTABLE/compass.cfg $TEAM_DIR/Config/Location/Osaka/ers7
    cp --preserve $COLTABLE/compass.cfg $MSD/open-r/APP/conf/Location/Osaka/ers7

  else
    echo "ERROR: Colortable directory not found!"
  fi 

  PLAYER="$TEAM_DIR/Deployment/Config/player.cfg"
  echo "copying player.cfg from $PLAYER"
  if test -f $PLAYER; then
    cp --preserve $PLAYER $MSD/open-r/APP/conf/player.cfg
  else
    echo "ERROR: player.cfg not found! ($PLAYER)"
  fi 

  WLAN="$TEAM_DIR/Deployment/Config/wlanconf.txt"
  echo "copying wlanconf.txt from $WLAN"
  if test -f $WLAN; then
    cp --preserve $WLAN $MSD/open-r/SYSTEM/CONF/wlanconf.txt
  else
    echo "ERROR: wlanconf.txt not found! ($WLAN)"
  fi 

  STICKINFO="$TEAM_DIR/Deployment/Config/stickinf.txt"
  echo "copying stickinf.txt from $STICKINFO"
  if test -f $STICKINFO; then
    cp --preserve $STICKINFO $MSD/stickinf.txt
  else
    echo "ERROR: stickinf.txt not found! ($WLAN)"
  fi 

  echo
  echo "Preparation complete!"

fi
#
# Change Log:
#
# $Log: copyfiles-package.bash,v $

