/**
* @file DefGlobalAnalyser.cpp
* 
* Implementation of class DefGlobalAnalyser
*
*/

#include "DefGlobalAnalyser.h"
#include "Tools/DynamicTeamTactic/RateableOptions.h"

DefGlobalAnalyser::DefGlobalAnalyser(const BehaviorControlInterfaces& interfaces)
: GlobalAnalyser(interfaces)
{
}

void DefGlobalAnalyser::update()
{
	calcWeights[RateableOptions::defGA_Neutral - RateableOptions::defGA_Neutral] = 1.0;
}

double DefGlobalAnalyser::getWeight(RateableOptions::TacticEntryTypeID tacticEntryType)
{
  return calcWeights[tacticEntryType - RateableOptions::defGA_Neutral];
}


/*
 * Change log :
 * $Log: DefGlobalAnalyser.cpp,v $
 * Revision 1.1  2004/07/22 22:38:30  kerdels
 * added DTT used by Open Challenge, RIP and Xabsl-Options will follow
 *
 *
 *
 *
 */
