/**
 * @file DefGlobalAnalyser.h
 * 
 * Implementation of class DefGlobalAnalyser.
 *
 * @author <A href=mailto:jochen@kerdels.de>Jochen Kerdels</A>
 */

#ifndef __DefGlobalAnalyser_h_
#define __DefGlobalAnalyser_h_

#include "Tools/DynamicTeamTactic/GlobalAnalyser.h"
#include "Tools/DynamicTeamTactic/RateableOptions.h"


/**
* @class DefGlobalAnalyser
*
* A simple implementation of the DefGlobalAnalyser class.
*
*/
class DefGlobalAnalyser : public GlobalAnalyser
{
private:
  
  double calcWeights[RateableOptions::defGA_Max - RateableOptions::defGA_Neutral];

public:

  /** 
   * Constructor.
   * @param interfaces The parameters of the DefGlobalAnalyser class.
   */
  DefGlobalAnalyser(const BehaviorControlInterfaces& interfaces);

	virtual void update();

	virtual double getWeight(RateableOptions::TacticEntryTypeID tacticEntryType);

};

#endif // __DefGlobalAnalyser_h_

/*
 * Change log :
 * $Log: DefGlobalAnalyser.h,v $
 * Revision 1.1  2004/07/22 22:38:30  kerdels
 * added DTT used by Open Challenge, RIP and Xabsl-Options will follow
 *
 *
 *
 */
