/**
* @file DefaultOptionRating.h
* 
* Implementation of class DefaultOptionRating.
*
* @author <A href=mailto:jochen@kerdels.de>Jochen Kerdels</A>
*/

#ifndef __DefaultOptionRating_h_
#define __DefaultOptionRating_h_

#include "Tools/DynamicTeamTactic/OptionRating.h"
#include "Tools/DynamicTeamTactic/ChooserRaterInterfaces.h"


/**
* @class DefaultOptionRating
*
* A simple implementation of the DefaultOptionRating class.
*
*/
class DefaultOptionRating : public OptionRating
{
public:
  
  
  /** 
  * Constructor.
  * @param interfaces The parameters of the OptionRating class.
  * @param collectedBeliefs The collected-Beliefs to work on.
  * @param chooserRaterInterfaces We want to talk to the tactic-Chooser.
  */
  DefaultOptionRating(const BehaviorControlInterfaces& interfaces,
    CollectedBeliefs& collectedBeliefs,
    ChooserRaterInterfaces& chooserRaterInterfaces
    );
  
  /** rating the Options in here... */
  virtual void rateOptions();
  
private:

  int ocrating[5];
  
  void doPreCals();
  
};

#endif // __DefaultOptionRating_h_

/*
* Change log :
* $Log: DefaultOptionRating.h,v $
* Revision 1.1  2004/07/22 22:38:31  kerdels
* added DTT used by Open Challenge, RIP and Xabsl-Options will follow
*
*
*/
