/** 
* @file GT2004DTTSymbols.h
*
* Declaration of class GT2004DTTSymbols.
*
* @author Jochen Kerdels
*/

#ifndef __GT2004DTTSymbols_h_
#define __GT2004DTTSymbols_h_

#include "../../BehaviorControl.h"
#include "Tools/Xabsl2/Xabsl2Engine/Xabsl2Engine.h"
#include "Tools/DynamicTeamTactic/TacticChooser.h"

/**
* The Xabsl2 symbols that are defined in "dtt-symbols.xml"
*
* @author Jochen Kerdels
*/ 
class GT2004DTTSymbols : public Xabsl2FunctionProvider, public BehaviorControlInterfaces
{
private:
  
public:
  
/*
* Constructor.
* @param interfaces The paramters of the BehaviorControl module.
* @param tacticChooser A Link to the actual tactic chooser
*/
  GT2004DTTSymbols(const BehaviorControlInterfaces& interfaces, 
    TacticChooser** tacticChooser);
  
  /** registers the symbols at an engine */
  void registerSymbols(Xabsl2Engine& engine);
  
  /** updates the symbols */
  void update();
  
  //!@name Input symbols
  //!@{
  
  // the choosen option
  RateableOptions::OptionID actualOption;
  
  // the type of the choosen option
  RateableOptions::OptionType actualOptionType;
  
  //!@}
  
  TacticChooser** actualTacticChooser;
  
};


#endif // __GT2004DTTSymbols_h_

/*
* Change Log
* 
* $Log: GT2004DTTSymbols.h,v $
* Revision 1.1  2004/07/22 22:38:20  kerdels
* added DTT used by Open Challenge, RIP and Xabsl-Options will follow
*
*
*
*/

