/**
* @file SLAMSymbols.h
*
* File created by the members of the Dutch Aibo Team 2005
*
* @author Jurgen Sturm, Silvain van Weers, Stefan Leijnen, Nico Assink, Niek Wijngaards 
*/
/** 
* @file SpecialVisionSymbols.h
*
* Declaration of class SpecialVisionSymbols.
*
* @author Matthias Jngel
*/

#ifndef __SLAMSymbols_h_
#define __SLAMSymbols_h_

#include "../../BehaviorControl.h"
#include "Tools/Xabsl2/Xabsl2Engine/Xabsl2Engine.h"
#include "Representations/Perception/SLAMData.h"

/**
* The Xabsl2 symbols that are defined in "special-vision-symbols.xml"
*
* @author Matthias Jngel
*/ 
class SLAMSymbols : public Xabsl2FunctionProvider, public BehaviorControlInterfaces
{
public:
/*
* Constructor.
* @param interfaces The paramters of the BehaviorControl module.
  */
  SLAMSymbols(BehaviorControlInterfaces& interfaces);
  
  /** registers the symbols at an engine */
  void registerSymbols(Xabsl2Engine& engine);
};


#endif // __SLAMSymbols_h_

/*
* Change Log
* 
* $Log: TaskVisionSymbols.h,v $
* Revision 1.1  2004/11/01 08:26:58  floris
* playing goalie has acces to taskvisiondata
*
* Revision 1.1  2004/06/08 15:39:14  andrew
* Renamed GT2003 to DT2004
*
* Revision 1.2  2004/02/27 11:31:13  wcaarls
* Import of Utrecht changes as of 26-02-2004.
*
* Revision 1.1.1.1  2004/01/15 12:30:25  bottens
*
*
* Revision 1.1.1.1  2003/07/02 09:40:23  cvsadm
* created new repository for the competitions in Padova from the 
* tamara CVS (Tuesday 2:00 pm)
*
* removed unused solutions
*
* Revision 1.1  2003/05/07 17:54:46  juengel
* Added missing symbols to DT2004BehaviorControl.
*
*/

