/**
* @file TaskVisionSymbols.cpp
*
* File created by the members of the Dutch Aibo Team 2005
*
* @author Jurgen Sturm, Silvain van Weers, Stefan Leijnen, Nico Assink, Niek Wijngaards 
*/
/** 
* @file SpecialVisionSymbols.cpp
*
* Implementation of class SpecialVisionSymbols.
*
* @author Matthias Jngel
*/

#include "TaskVisionSymbols.h"

TaskVisionSymbols::TaskVisionSymbols(BehaviorControlInterfaces& interfaces)
: BehaviorControlInterfaces(interfaces)
{
}


void TaskVisionSymbols::registerSymbols(Xabsl2Engine& engine)
{
  
  engine.registerEnumeratedOutputSymbol("task-vision-request",(int*)&taskVisionData.taskSolution1); 
  engine.registerEnumeratedOutputSymbolEnumElement("task-vision-request","task-vision.dt2004",0);
  engine.registerEnumeratedOutputSymbolEnumElement("task-vision-request","task-vision.position",1);
  engine.registerEnumeratedOutputSymbolEnumElement("task-vision-request","task-vision.clear",2);
  engine.registerEnumeratedOutputSymbolEnumElement("task-vision-request","task-vision.find-orientation",3);
  engine.registerEnumeratedOutputSymbolEnumElement("task-vision-request","task-vision.return",4);
  engine.registerEnumeratedOutputSymbolEnumElement("task-vision-request","task-vision.odometry",5);
  engine.registerEnumeratedOutputSymbolEnumElement("task-vision-request","task-vision.striker",6);
 
  engine.registerDecimalInputSymbol("task-vision.validityTask",&taskVisionData.getValidityTask());
 
}

/*
* Change Log
* 
* $Log: TaskVisionSymbols.cpp,v $
* Revision 1.7  2005/02/04 11:45:32  floris
* last updates made to task image processing algorithms
*
* Revision 1.6  2005/01/07 15:32:59  floris
* task-vision-request striker works much better then DT2004
*
* Revision 1.5  2004/12/08 17:22:53  floris
* Task Image Processor restructured
*
* Revision 1.4  2004/11/18 14:18:42  floris
* simple checking of pose for goalie-guard implemented
*
* Revision 1.3  2004/11/12 16:32:40  floris
* keeper further improved
*
* Revision 1.2  2004/11/05 09:44:55  floris
* taskVisionRequest implemented
*
* Revision 1.1  2004/11/01 08:26:58  floris
* playing goalie has acces to taskvisiondata
*
* Revision 1.1  2004/06/08 15:39:14  andrew
* Renamed GT2003 to DT2004
*
* Revision 1.2  2004/02/27 11:31:13  wcaarls
* Import of Utrecht changes as of 26-02-2004.
*
* Revision 1.1.1.1  2004/01/15 12:30:25  bottens
*
*
* Revision 1.1.1.1  2003/07/02 09:40:23  cvsadm
* created new repository for the competitions in Padova from the 
* tamara CVS (Tuesday 2:00 pm)
*
* removed unused solutions
*
* Revision 1.1  2003/05/07 17:54:46  juengel
* Added missing symbols to DT2004BehaviorControl.
*
*/

