/**
*
*/

#ifndef __GlobalAlignment_h_
#define __GlobalAlignment_h_

#include "LocalAlignment.h"

#define HISTORY_BUFFER 32
#define OFFSET_RANGE 10.0
#define SEEK_STEPS 50
#define KERNEL_SIGMA 10

class GlobalAlignment {
public:
	GlobalAlignment();

	LocalAlignment history[HISTORY_BUFFER];
	int historyLength,historyOldestAlignmentUsed;
	double seenOffset[HISTORY_BUFFER];
	bool seenOffsetValid[HISTORY_BUFFER];
	double worldSeen[MAX_SECTORS];
	double worldSeenSmoothed[MAX_SECTORS];
	double seenSize[MAX_SECTORS];
	
	double matchSlope,matchAverage;
	double scaleSlope,scaleAverage;

	RobotPose estimatedPose;
	RobotPose estimatedValidity;

	void reset();
	void aquire(LocalAlignment &newAlignment);
	void execute();
	void match();
	void estimateSize();
	void computePosition();
	void visualizeMatch(Image &debugImage);

};

#endif// __GlobalAlignment_h_
/*
*/
