/**
*
*/

#ifndef __ManualPositions_h_
#define __ManualPositions_h_

#include "Representations/Perception/PanoramaLibrary.h"
#include "HistogramDistributionLibrary.h"
#include "Tools/Debugging/DebugImages.h"
#include "Representations/Perception/Image.h"
#include "Representations/Perception/LandmarksPercept.h"
#include "Representations/Perception/SLAMData.h"
#include "Representations/Cognition/RobotPose.h"
#include "Representations/Perception/PanoramaParameters.h"

enum ManualPositionType {positionLearn,positionTest,positionFree};

class ManualPosition {
public:
	RobotPose pose;
	int frameNumber;
	char name[255];
	ManualPositionType type;
	
};

class ManualPositions {
public:
	ManualPosition storedPosition[MAX_MANUAL_POSITIONS];
	int positions;
	int currentPosition;

	const LandmarksPercept &landmarksPercept;
	RobotPose &robotPose;
	SLAMData &slamData;

	ManualPositions(const LandmarksPercept &landmarksPercept,RobotPose &robotPose,SLAMData &slamData);
	void execute();

};


#endif// __ManualPositions_h_

/*
*/
