/**
* @file BarCodeReader.h
* 
* Definition of class BarCodeReader
* This class recognizes a givem barcode from the image and extracts a 6 bit number of it
*
* @author <A href=mailto:goehring@informatik.hu-berlin.de>Daniel Ghring</A>
*/

#ifndef __BarCodeReader_h_
#define __BarCodeReader_h_

#include "SpecialVision.h"

/** A BarCode Reader */
class BarCodeReader : public SpecialVision
{
public:
  /** Constructor 
  * @param interfaces The interfaces of the SpecialVision module */
  BarCodeReader(const SpecialVisionInterfaces& interfaces);

  /** Executes the module */
  virtual void execute();
};

#endif// __BarCodeReader_h_

/*
* Change log :
* 
* $Log: BarCodeReader.h,v $
* Revision 1.1.1.1  2004/05/22 17:22:25  cvsadm
* created new repository GT2004_WM
*
* Revision 1.2  2004/03/08 02:11:53  roefer
* Interfaces should be const
*
* Revision 1.1  2003/10/06 14:10:13  cvsadm
* Created GT2004 (M.J.)
*
* Revision 1.1.1.1  2003/07/02 09:40:24  cvsadm
* created new repository for the competitions in Padova from the 
* tamara CVS (Tuesday 2:00 pm)
*
* removed unused solutions
*
* Revision 1.2  2003/02/07 19:23:47  goehring
* Added Comments
*
* Revision 1.1  2003/01/29 10:37:21  juengel
* Added BarCodeReader.
*
*
*/
