/**
 * @file GT2004TeamBallLocator.h
 * 
 * Implementation of class DefaultTeamBallLocator.
 *
 * @author <a href="mailto:roefer@tzi.de">Thomas Rfer</a>
 * @author Martin Ltzsch
 */

#ifndef __GT2004TeamBallLocator_h_
#define __GT2004TeamBallLocator_h_

#include "TeamBallLocator.h"

/**
* @class GT2004TeamBallLocator
*
* A simple solution of the TeamBallLocator module.
*
* @author <a href="mailto:roefer@tzi.de">Thomas Rfer</a>
* @author Martin Ltzsch
*/
class GT2004TeamBallLocator : public TeamBallLocator
{
public:
  /** 
  * Constructor.
  * @param interfaces The paramters of the TeamBallLocator module.
  */
  GT2004TeamBallLocator(const TeamBallLocatorInterfaces& interfaces);

  /** Executes the module */
  virtual void execute();
};

#endif// __ATH2004TeamBallLocator_h_

/*
 * Change log :
 * 
 * $Log: GT2004TeamBallLocator.h,v $
 * Revision 1.2  2004/09/08 14:39:03  wachter
 * - Fixed some doxygen-errors
 *
 * Revision 1.1  2004/07/10 00:18:32  spranger
 * renamed (readded) for coderelease
 *
 * Revision 1.1.1.1  2004/05/22 17:22:25  cvsadm
 * created new repository GT2004_WM
 *
 * Revision 1.1  2004/04/05 17:56:47  loetzsch
 * merged the local German Open CVS of the aibo team humboldt with the tamara CVS
 *
 */
