/**
* @file NetConfig.h
*
* File modified by the members of the Dutch Aibo Team 2005
*
* @author Jurgen Sturm, Silvain van Weers, Stefan Leijnen, Nico Assink, Niek Wijngaards 
*/
/** 
* @file  Platform/Aperios1.3.2/NetConfig.h
*
* Configuration for Network-Ports
*
* @author <A href=mailto:robocup@m-wachter.de>Michael Wachter</A>
*/

#ifndef	_NetConfig_H_
#define	_NetConfig_H_

// ports changed: DutchAiboTeam
// ports changed again, for osaka (10000 + 100*teamnr = 11800)
#define DDPPORT 11810        /**< Port for "Dog Discovery Protocol" */
#define TEAMPORTBASE 11820   /**< Baseport for team communication. Up to 4 following ports are used. */
#define DEBUGPORT 0xA1BD      /**< Port for debugging.*/

#endif 

/*
 *
 * Changelog :
 *
 * $Log: NetConfig.h,v $
 * Revision 1.2  2004/09/08 12:41:43  wachter
 * - Fixed some warnings
 * - Fixed some documentation in network-code
 *
 * Revision 1.1.1.1  2004/05/22 17:23:26  cvsadm
 * created new repository GT2004_WM
 *
 * Revision 1.2  2004/05/14 15:03:47  wachter
 * - really using network-configuration now
 *
 * Revision 1.1  2004/05/14 14:12:08  wachter
 * - Added communication support for 5 robots
 * - rewrote parts of team-communication to be faster and more stable
 *
 *
 */
