/** 
* @file  Platform/Aperios1.3.2/NetHandler.h
*
* Class NetHandler : base-class for TCPHandler and UDPHandler
*
* @author <A href=mailto:robocup@m-wachter.de>Michael Wachter</A>
*/

#ifndef	_NetHandler_H_
#define	_NetHandler_H_

#include <stdio.h>
#include <iostream.h>

/**
 * base-class for TCPHandler and UDPHandler
 */
class NetHandler
{
public:
  virtual void sendPackage(int senderNumber,void* data,int size){}; /**< has to be overwritten by the Handler */
};

#endif 

/*
 *
 * Changelog :
 *
 * $Log: NetHandler.h,v $
 * Revision 1.2  2004/09/12 20:10:47  wachter
 * Documentation-fixes
 *
 * Revision 1.1.1.1  2004/05/22 17:23:26  cvsadm
 * created new repository GT2004_WM
 *
 * Revision 1.4  2004/01/20 14:21:41  wachter
 * - Added sender-number to NetSender
 * - worked on with Team-Communication
 *
 * Revision 1.3  2004/01/06 10:01:13  wachter
 * Added comments
 *
 * Revision 1.2  2004/01/03 16:18:24  wachter
 * debug-communication mostly working now
 *
 * Revision 1.1  2003/12/21 19:27:02  wachter
 * Added classes for Sender/Receiver over TCP and UDP.
 * ( PLEASE DO NOT USE THIS NOW ! )
 *
 *
 */
