/**
* @file RobotPose.cpp
*
* contains the implementation of the class RobotPose
*/

#include "RobotPose.h"

In& operator>>(In& stream,RobotPose& robotPose)
{
  stream.read(&robotPose,sizeof(RobotPose));
  return stream;
}

Out& operator<<(Out& stream, const RobotPose& robotPose)
{
  stream.write(&robotPose,sizeof(RobotPose));
  return stream;
}

/*
 * Change log :
 * 
 * $Log: RobotPose.cpp,v $
 * Revision 1.1.1.1  2004/05/22 17:25:15  cvsadm
 * created new repository GT2004_WM
 *
 * Revision 1.3  2003/11/18 15:19:24  dueffert
 * serious bugs fixed
 *
 * Revision 1.2  2003/11/14 19:02:25  goehring
 * frameNumber added
 *
 * Revision 1.1  2003/10/07 10:07:01  cvsadm
 * Created GT2004 (M.J.)
 *
 * Revision 1.1.1.1  2003/07/02 09:40:22  cvsadm
 * created new repository for the competitions in Padova from the 
 * tamara CVS (Tuesday 2:00 pm)
 *
 * removed unused solutions
 *
 * Revision 1.1  2002/09/10 15:26:39  cvsadm
 * Created new project GT2003 (M.L.)
 * - Cleaned up the /Src/DataTypes directory
 * - Removed Challenge Code
 * - Removed processing of incoming audio data
 * - Renamed AcousticMessage to SoundRequest
 *
 * Revision 1.1.1.1  2002/05/10 12:40:13  cvsadm
 * Moved GT2002 Project from ute to tamara.
 *
 * Revision 1.6  2002/02/13 22:43:02  roefer
 * First working versions of DefaultLandmarksPerceptor and MonteCarloSelfLocator
 *
 * Revision 1.5  2002/02/05 03:36:12  loetzsch
 * replaced direct member access by
 * inline const VALUE& get...() const   and
 * inline void set...(const Value&) methods.
 *
 * Revision 1.4  2002/01/13 12:16:16  AndySHB
 * no message
 *
 * Revision 1.3  2001/12/10 17:47:06  risler
 * change log added
 *
 */
