/**
* @file PanoramaParameters.h
*
*/
#ifndef __PanoramaParameters_h_
#define __PanoramaParameters_h_

//#include "Representations/Perception/PanoramaParameters.h"

#define DIAGONAL (cameraResolutionHeight_ERS7 + cameraResolutionWidth_ERS7)
#define HORIZON_CORRECTION (15)

extern int CLUSTERS;
extern int PLAIN_COLORS_ONLY;
extern int OPTIMIZATIONS;
extern int SECTORS;
extern int SCANNING_X;
extern int SCANNING_Y;

#define MAX_CLUSTERS 20
#define MAX_SECTORS 80

#define BINS 5
#define FREQ_MAX 20
// likelihood is between 0..1
#define MIN_LIKELIHOOD 0.05

#define MAX_MANUAL_POSITIONS 100
// magnitude higher than threshold_high => search for maximum in magnitude
#define MAGNITUDE_THRESHOLD_HIGH 100
// magnitude lower than threshold_low => pixel has valid color
#define MAGNITUDE_THRESHOLD_LOW 50
// length of scanlet
#define SCANLET_LENGTH 20
// length of scanlet
#define SCANLET_DISPLAY_LENGTH 5
// offset to original horizon (capture everything that could be above), 7deg is ok
#define HORIZON_ABOVE -70*(PI/180)
// color buffer, 10000 is good
#define COLOR_BUFFER_SIZE 2000
// size of initial color table
#define COLLECT_COLORS 50000
// amount of color cubes in color space histogram per dimension
// size of color matrix
#define COLOR_CUBES 32
#define COLOR_MATRIX_SIZE 1024
// clusters
#define COLOR_CLUSTERS 10
// histogram cutoff
#define COLOR_EDGE_ABOVE 0.95
// initial merge distance
#define INITIAL_MERGE_DISTANCE 0


#define MAX_PANORAMAS 5
#define MATCH_BUFFER 30
#define ALIGNMENT_BUFFER (MATCH_BUFFER*20)
#define SIGMA_PHASE 20
#define MIN_OBJECT_SIZE 10

#define HORIZON_SIZE 60






#endif //__PanoramaParameters_h_

