/**
* @file GT2004WalkingEngineParamSetDlgBar.h
* Declaration of class GT2004WalkingEngineParamSetDlgBar.
* @author Uwe Dffert 
*/

#ifndef __GT2004WalkingEngineParamSetDlgBar_h_
#define __GT2004WalkingEngineParamSetDlgBar_h_

#include "StdAfx.h"
#include "RobotControlDialogBar.h"
#include "Modules/WalkingEngine/GT2004ParameterSet.h"

/** 
* @class GT2004ParamSetDlgBar
* A dialog bar for working with GT2004ParameterSets
* @author Uwe Dffert
*/
class CGT2004WalkingEngineParamSetDlgBar : public CRobotControlDialogBar
{
public:
  CGT2004WalkingEngineParamSetDlgBar();
  bool handleMessage(InMessage& message);

  int currentParametersNumber;
  GT2004Parameters* currentParam;
  GT2004Parameters extraParam;
  double speed;
  double ratio;
  double direction;

  //{{AFX_DATA(CGT2004ParameterSetDlgBar)
	enum { IDD = IDD_DIALOG_BAR_GT2004WALKINGPARAMETERSET };
	CStatic	m_correctLabel;
  CStatic m_rotLabel;

	CComboBox	m_FootMode;
	CComboBox	m_ChooseRatio;
	CComboBox	m_ChooseDirection;
	CComboBox	m_ChooseSpeed;
  CButton m_autoCheck;
  GT2004ParametersSet paramSet;
	//}}AFX_DATA


  //{{AFX_VIRTUAL(CGT2004ParameterSetDlgBar)
protected:
  virtual void DoDataExchange(CDataExchange* pDX);  
  virtual BOOL OnInitDialog();
  //}}AFX_VIRTUAL
  void copyToClipboard(bool useInvKin=false);
  void pasteFromClipboard(bool useInvKin=false);
  void setParametersSelection();

  //{{AFX_MSG(CGT2004ParameterSetDlgBar)
	afx_msg void OnSend();
	afx_msg void OnLoad();
	afx_msg void OnSave();
	afx_msg void OnMirror();
	afx_msg void OnMeasure();
	afx_msg void OnChangeSpeed();
	afx_msg void OnChangeRatio();
	afx_msg void OnChangeDirection();
  afx_msg void OnChangeRequest();
	afx_msg void OnSelchangeChooseSet();
  afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP();
};

#endif // __GT2004WalkingEngineParamSetDlgBar_h_

/*
* Change log :
* 
* $Log: GT2004WalkingEngineParamSetDlgBar.h,v $
* Revision 1.2  2004/09/09 10:15:57  spranger
* fixed doxygen-errors
*
* Revision 1.1  2004/07/14 21:10:23  spranger
* renamed GT2004ParameterSettingsDialogBar to GT2004WalkingParameterSettingsDialogBar
*
* Revision 1.1  2004/07/10 00:18:31  spranger
* renamed (readded) for coderelease
*
* Revision 1.3  2004/07/07 15:10:35  dueffert
* copy'n'paste invkin added
*
* Revision 1.2  2004/06/09 08:18:35  dueffert
* UDParametersSetDialog improved
*
* Revision 1.1.1.1  2004/05/22 17:28:17  cvsadm
* created new repository GT2004_WM
*
* Revision 1.9  2004/05/20 17:21:28  dueffert
* UDParametersDialog improved
*
* Revision 1.8  2004/04/01 12:12:18  dueffert
* update bug and copy'n'paste bug fixed
*
* Revision 1.7  2004/03/29 15:33:49  dueffert
* speed change added
*
* Revision 1.6  2004/03/27 08:46:36  dueffert
* copy'n'paste support via context menu added
*
* Revision 1.5  2004/03/16 10:30:43  dueffert
* UI update and output improved
*
* Revision 1.4  2004/03/03 08:29:35  dueffert
* two UDEvolutionRequests added
*
* Revision 1.3  2004/02/27 16:40:56  dueffert
* UDEvolutionRequest introduced
*
* Revision 1.2  2003/12/09 14:20:03  dueffert
* numerous UD improvements
*
* Revision 1.1  2003/12/02 18:07:52  dueffert
* first working not yet calibrated version of UDWalkingEngine added
*
*
*/
