/**
* @file GenericModalBinary.h
* 
* Declaration of a generic dialog for confirmation of actions.
*/

#include "resource.h"
#ifndef __CGenericModalBinary_h
#define __CGenericModalBinary_h

class CGenericModalBinary : public CDialog
{
public:
	CGenericModalBinary(CString buttonTrue, CString buttonFalse, CString descriptiveText, CWnd* pParent = NULL); 

	//{{AFX_DATA(GenericModalBinary)
	enum { IDD = IDD_DIALOG_MODAL_BINARY };
	//}}AFX_DATA


	//{{AFX_VIRTUAL(GenericModalBinary)
	protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

protected:

  CString description, textFalse, textTrue;

	//{{AFX_MSG(GenericModalBinary)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}

#endif //__GenericModalBinary_h

/*
 * Change log :
 * 
 * $Log: GenericModalBinary.h,v $
 * Revision 1.1.1.1  2004/05/22 17:28:24  cvsadm
 * created new repository GT2004_WM
 *
 * Revision 1.2  2004/02/25 13:41:27  jhoffman
 * - removed include of "resource.h" in "stdafx.h" to force compile when "resource.h" is changed
 * - layout change should work for everybody now
 * - cancel works for "new" layout dialog
 *
 * Revision 1.1  2004/02/23 13:27:25  jhoffman
 * - changes to Main-menu are shown ... this currently results in one additional menu (!) somebody please fix this!
 * - added GenericModalBinary-dialog: can be used to create a modal dialog where you can specify the button labels and the descriptive text (like APX...ModalDialog but you can specify what is written on the buttons)
 * - CameraToolBar: mode, shutter, gain extracted from dropdown
 * - ToolBarEx: added AddString method to write const. strings on a toolbar
 *
 *
 */
