/**
* @file WLANDeployDialog.h
*
* File created by the members of the Dutch Aibo Team 2005
*
* @author Jurgen Sturm, Silvain van Weers, Stefan Leijnen, Nico Assink, Niek Wijngaards 
*/
/**
 * @file WLANDeployDialog.h
 * 
 * Declaration of WLAN Deploy dialog in the RobotControl project.
 *
 * @author Jurgen Sturm
 */

#ifndef __WLANDeployDialog_h_ 
#define __WLANDeployDialog_h_ 

#include "StdAfx.h"
#include "resource.h"

#include "RobotControlPhysicalRobots.h"

/**
 * @class CWLANDeployDialog
 * 
 * Provides the possibility to enter new and change existing WLAN Deploys.
 */
class CWLANDeployDialog : public CDialog
{
public:
  CWLANDeployDialog(CWnd* pParent = NULL);
  void setWLANConfiguration(CRobotControlWLANConfiguration* externConfig);
  
  //{{AFX_DATA(CWLANDeployDialog)
  enum { IDD = IDD_DIALOG_WLAN_DEPLOY };

  CButton m_PingAll;
  CButton m_RefreshAll;
  CButton m_Refresh;
  CButton m_WLANUpdatesColortable;
  CButton m_WLANUpdatesBinaries;
 
  CString m_Aibo[8];
  CString m_Stick[8];
  CString m_IP[8];

  CComboBox m_Binaries[8];
  CComboBox m_Colortable[8];
  CStatic m_Ping[8];
  CStatic m_Indicator[8];
  CComboBox m_MS;

  //}}AFX_DATA
  
  
  //{{AFX_VIRTUAL(CWLANDeployDialog)
protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
  //}}AFX_VIRTUAL
  
protected:
  CRobotControlWLANConfiguration* config;
  CString IPToStr(unsigned long ip);
  void updateSlotFromFile(CString fname,int forcedNumber);
  void setPingIcon(int number,int status);
  int getAiboName(const char* mac, char* name);
  void refreshBinaryCombo();
  void refreshColortableCombo();
  void copyStick(int number);
  void copyWLAN(int number);
  void prepareImage(int number);
  void selectIndicator(int number);
  //{{AFX_MSG(CWLANDeployDialog)
  virtual BOOL OnInitDialog();
  afx_msg void OnRefresh();
  afx_msg void OnRefreshAll();
  afx_msg void OnPingAll();
  afx_msg void OnSnapshot();
  afx_msg void OnCopyStick0();
  afx_msg void OnCopyStick1();
  afx_msg void OnCopyStick2();
  afx_msg void OnCopyStick3();
  afx_msg void OnCopyStick4();
  afx_msg void OnCopyStick5();
  afx_msg void OnCopyStick6();
  afx_msg void OnCopyStick7();
  afx_msg void OnCopyWLAN0();
  afx_msg void OnCopyWLAN1();
  afx_msg void OnCopyWLAN2();
  afx_msg void OnCopyWLAN3();
  afx_msg void OnCopyWLAN4();
  afx_msg void OnCopyWLAN5();
  afx_msg void OnCopyWLAN6();
  afx_msg void OnCopyWLAN7();
  virtual void OnOK();
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP();
private:
};

//{{AFX_INSERT_LOCATION}}

#endif // __WLANDeployDialog_h_

/*
* Change log :
* 
* $Log: WLANDeployDiog.h,v $
*
*
*/
