/**
* @file RobotControlFieldView.h
*
* Declaration of class CRobotControlFieldView
*
* @author Martin Ltzsch
*/
#ifndef __RobotControlFieldView_h_
#define __RobotControlFieldView_h_

#include "StdAfx.h"

/**
* @class CRobotControlFieldView
*
* The main window that contains the field view.
* @author Martin Ltzsch
*/
class CRobotControlFieldView : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CRobotControlFieldView);
public:
	CRobotControlFieldView();

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CChildFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

	virtual ~CRobotControlFieldView();

  CRect rectForMetaFilePlay;

  //{{AFX_MSG(CRobotControlFieldView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnPaint();
  afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP();
};


#endif // __RobotControlFieldView_h_

/*
 * Change log :
 * 
 * $Log: RobotControlFieldView.h,v $
 * Revision 1.1.1.1  2004/05/22 17:26:29  cvsadm
 * created new repository GT2004_WM
 *
 * Revision 1.2  2003/12/15 13:05:04  loetzsch
 * RobotControl now displays a splash screen at the beginning
 *
 * Revision 1.1  2003/10/07 10:09:37  cvsadm
 * Created GT2004 (M.J.)
 *
 * Revision 1.1.1.1  2003/07/02 09:40:25  cvsadm
 * created new repository for the competitions in Padova from the 
 * tamara CVS (Tuesday 2:00 pm)
 *
 * removed unused solutions
 *
 * Revision 1.5  2003/05/11 23:51:02  dueffert
 * Depend now works with RobotControl too
 *
 * Revision 1.4  2002/11/21 16:08:39  dueffert
 * doxygen comments corrected
 *
 * Revision 1.3  2002/10/02 15:52:53  juengel
 * The status bar shows the type of the current message in the LogPlayer tool bar.
 *
 * Revision 1.2  2002/09/20 23:28:33  juengel
 * Moved instance of DebugDrawingManager to RobotControlMainFrame.
 *
 * Revision 1.1  2002/09/10 15:49:04  cvsadm
 * Created new project GT2003 (M.L.)
 * - Cleaned up the /Src/DataTypes directory
 * - Removed challenge related source code
 *
 * Revision 1.5  2002/09/01 17:20:34  loetzsch
 * tidied up the MfcTools/ directory. Created directories
 * MfcTools/DockingControlBars and MfcTools/IEStyleToolbars.
 *
 * Revision 1.4  2002/08/30 21:08:11  dueffert
 * AboutDlg added
 *
 * Revision 1.3  2002/08/30 18:14:43  dueffert
 * further docu bugs fixed
 *
 * Revision 1.2  2002/08/30 17:12:50  dueffert
 * doxygen parser bugs fixed, docu added
 *
 * Revision 1.1  2002/08/07 10:49:42  loetzsch
 * - simplified field view window
 *
 */
